/*--------------------------------------------------------------------------
 *
 *  queue.h--
 *    
 *  Copyright (c) 2015, FAMNIT, University of Primorska
 *--------------------------------------------------------------------------
 */

#ifndef QUEUE_H
#define QUEUE_H


/* queue of sets */

typedef struct queue_element {
  set_type 		set;   	/* set element */
  struct queue_element *prev;   /* ptr to previous queue element. */
} queue_element;

typedef struct queue_type {
    queue_element  *first_el;  	/* first element of the queue */
    queue_element  *last_el;   	/* last element of the queue */
} queue_type;

queue_type  *wqu;   /* working queue */
 
/*---------------------- Exported functions --------------------------------
 */

extern void 	queue_new(queue_type **queue);
extern void 	queue_init(queue_type *queue);
extern void 	queue_free(queue_type *queue);
extern boolean 	queue_empty(queue_type *queue);
extern void 	queue_add(queue_type *queue, set_type *S);
extern void 	queue_add_to_end(queue_type *queue, set_type *S);
extern void 	queue_get(queue_type *queue, set_type *S);
extern void 	queue_print(queue_type *queue);
extern int 	queue_count(queue_type *queue);

#endif /* QUEUE_H */

